#include <stdlib.h>
#define USE_AND_OR /* To enable AND_OR mask setting */
#include <ports.h>
#include <pps.h>
#include <timer.h>
#include <outcompare.h>
#include <adc.h>
//#include "global.h"
#include "btstack/debug.h"
#include "btstack/btstack.h"
#include <btstack/hci_cmds.h>
#include <btstack/run_loop.h>

#include "btstack/hci.h"
#include "btstack/l2cap.h"
#include "btstack/btstack_memory.h"
#include "btstack/remote_device_db.h"
//#include "btstack/config.h"

unsigned	timer_counter=0;
unsigned	led1_on_count=0;
uint8_t		led1_on_state=0;
uint8_t		startup_state=0;

WORD	sensor_advalue[6];
int		sense_ly=0;			//^Cϐ(0:~ 100:Oi -100:)
int		sense_ry=0;			//E^Cϐ(0:~ 100:Oi -100:)

hci_transport_t * hci_transport_picusb_instance();

#if defined(__PIC24FJ64GB004__)
	_CONFIG1(WDTPS_PS2048 & FWPSA_PR128 & WINDIS_OFF & FWDTENDEF & ICSDEF & GWRP_OFF & GCP_OFF & JTAGEN_OFF)
	_CONFIG2(POSCMOD_NONE & I2C1SEL_PRI & IOL1WAY_OFF & OSCIOFNC_ON & FCKSM_CSDCMD & FNOSC_FRCPLL & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
	_CONFIG3(WPFP_WPFP0 & SOSCSEL_IO & WUTSEL_LEG & WPDIS_WPDIS & WPCFG_WPCFGDIS & WPEND_WPENDMEM)
	_CONFIG4(DSWDTPS_DSWDTPS3 & DSWDTOSC_LPRC & RTCOSC_SOSC & DSBOREN_OFF & DSWDTEN_OFF)
#else

    #error Cannot define configuration bits.

#endif

BYTE        deviceAddress;  // Address of the device on the USB
bd_addr_t addr_global;

void __attribute__ ((interrupt,no_auto_psv)) _OC1Interrupt(void)
{
	OC1_Clear_Intr_Status_Bit;
}

void __attribute__ ((interrupt,no_auto_psv)) _OC2Interrupt(void)
{
	OC2_Clear_Intr_Status_Bit;
}

void __attribute__ ((interrupt,no_auto_psv)) _ADC1Interrupt(void)
{
	ADC1_Clear_Intr_Status_Bit;
	sensor_advalue[0]=ADC1BUF0;
	sensor_advalue[1]=ADC1BUF1;
	sensor_advalue[2]=ADC1BUF2;
	sensor_advalue[3]=ADC1BUF3;
	sensor_advalue[4]=ADC1BUF4;
	sensor_advalue[5]=ADC1BUF5;
}

void __attribute__ ((interrupt,no_auto_psv)) _CNInterrupt(void)
{
	InputChange_Clear_Intr_Status_Bit;

	if(get_switch1()){
		led3_on();
	}else{
		led3_off();
	}

	if(get_switch2()){
		led4_on();
	}else{
		led4_off();
	}
}

BOOL InitializeSystem ( void )
{
   #if defined(__PIC24FJ64GB004__)
	    {
	        unsigned int pll_startup_counter = 600;
	        CLKDIVbits.PLLEN = 1;
	        while(pll_startup_counter--);
	    }

		AD1PCFG = 0xffff;
	    CLKDIV = 0;    // Set PLL prescaler (1:1)
    #endif

	led1_setup();
	led2_setup();
	led3_setup();
	led4_setup();
	led5_setup();

	led1_on();
	led2_on();
	led3_on();
	led4_on();
	led5_on();

	switch1_setup();
	switch2_setup();

	motor_a1_setup();
	motor_a2_setup();
	motor_pwma_setup();

	motor_b1_setup();
	motor_b2_setup();
	motor_pwmb_setup();

	OpenTimer2(T2_ON|PWM_PRESCALER,PWM_WIDTH);
	OpenOC1(OC_IDLE_CON|OC_TIMER2_SRC|OC_PWM_EDGE_ALIGN,OC_SYNC_TRIG_IN_TMR2,0,0);
	SetPriorityIntOC1(INT_PRI_4);
	EnableIntOC1;
	SetDCOC1PWM(0,0);

	OpenOC2(OC_IDLE_CON|OC_TIMER2_SRC|OC_PWM_EDGE_ALIGN,OC_SYNC_TRIG_IN_TMR2,0,0);
	SetPriorityIntOC2(INT_PRI_4);
	EnableIntOC2;
	SetDCOC2PWM(0,0);

	OpenADC10(
		ADC_MODULE_ON|ADC_IDLE_CONTINUE|ADC_FORMAT_INTG|ADC_CLK_AUTO|ADC_AUTO_SAMPLING_ON|ADC_SAMP_ON,
		ADC_VREF_AVDD_AVSS|ADC_SCAN_ON|/* ADC_INTR_6_CONV| */ ADC_INTR_4_CONV|ADC_ALT_BUF_OFF|ADC_ALT_INPUT_OFF,
		ADC_CONV_CLK_SYSTEM|ADC_SAMPLE_TIME_31|ADC_CONV_CLK_128Tcy,
		ENABLE_AN0_ANA|ENABLE_AN1_ANA|ENABLE_AN4_ANA|ENABLE_AN5_ANA/*|ENABLE_AN6_ANA|ENABLE_AN7_ANA*/,
		ADC_SCAN_AN0|ADC_SCAN_AN1|ADC_SCAN_AN4|ADC_SCAN_AN5/*|ADC_SCAN_AN6|ADC_SCAN_AN7*/
	);
	SetPriorityIntADC1(INT_PRI_4);
	EnableIntADC1;

	SetPriorityIntInputChange(INT_PRI_4);	
	EnableIntInputChange;

//	led1_off();
//	led2_off();
//	led3_off();
//	led4_off();
//	led5_off();

#if	__DEBUG
	u1tx_setup();
    // Init UART
    UART1Init(BAUDRATE1);
#endif

#if	0
	u1rx_setup();
	u1cts_setup();
	u1rts_setup();
	sto_setup();	//for debug out
#endif


#if	ENABLE_KNIGHTRIDER
	kr_led1_setup();
	kr_led2_setup();
	kr_led3_setup();
	kr_led4_setup();
	kr_led5_setup();
	kr_led6_setup();
	kr_led7_setup();
	kr_led8_setup();
#endif


#if	0//__DEBUG
    UART2Init();
#endif

    return TRUE;
} // InitializeSystem

BOOL USB_ApplicationEventHandler ( BYTE address, USB_EVENT event, void *data, DWORD size )
{
    #ifdef USB_BLUETOOTH_SUPPORT_SERIAL_NUMBERS
        BYTE i;
    #endif

    // Handle specific events.
    switch (event)
    {
        case EVENT_BLUETOOTH_ATTACH:
            if (size == sizeof(BLUETOOTH_DEVICE_ID))
            {
                deviceAddress   = ((BLUETOOTH_DEVICE_ID *)data)->deviceAddress;
                log_info( "Bluetooth device attached - event, deviceAddress=%d\r\n",deviceAddress );
                #ifdef USB_BLUETOOTH_SUPPORT_SERIAL_NUMBERS
                    for (i=1; i<((BLUETOOTH_DEVICE_ID *)data)->serialNumberLength; i++)
                    {
                        xputc( ((BLUETOOTH_DEVICE_ID *)data)->serialNumber[i] );
                    }
	                xputs( "\r\n" );
                #endif
                return TRUE;
            }
            break;

        case EVENT_BLUETOOTH_DETACH:
            deviceAddress   = 0;
            log_info( "Bluetooth device detached - event\r\n" );
            return TRUE;

        case EVENT_BLUETOOTH_TX_CMD_DONE:           // The main state machine will poll the driver.
            return TRUE;

        case EVENT_BLUETOOTH_TX_ACL_DONE:           // The main state machine will poll the driver.
            return TRUE;

        case EVENT_BLUETOOTH_RX_EVENT_DONE:
			if(*(DWORD*)data){
				event_bluetooth_rxEvent_done((WORD)(*(DWORD*)data));
			}
            return TRUE;

        case EVENT_BLUETOOTH_RX_ACL_DONE:
			if(*(DWORD*)data){
				event_bluetooth_rxAcl_done((WORD)(*(DWORD*)data));
			}
            return TRUE;

        case EVENT_VBUS_REQUEST_POWER:
            // We'll let anything attach.
            return TRUE;

        case EVENT_VBUS_RELEASE_POWER:
            // We aren't keeping track of power.
            return TRUE;

        case EVENT_HUB_ATTACH:
            log_info( "\r\n***** USB Error - hubs are not supported *****\r\n" );
            return TRUE;
            break;

        case EVENT_UNSUPPORTED_DEVICE:
            log_info( "\r\n***** USB Error - device is not supported *****\r\n" );
            return TRUE;
            break;

        case EVENT_CANNOT_ENUMERATE:
            log_info( "\r\n***** USB Error - cannot enumerate device *****\r\n" );
            return TRUE;
            break;

        case EVENT_CLIENT_INIT_ERROR:
            log_info( "\r\n***** USB Error - client driver initialization error *****\r\n" );
            return TRUE;
            break;

        case EVENT_OUT_OF_MEMORY:
            log_info( "\r\n***** USB Error - out of heap memory *****\r\n" );
            return TRUE;
            break;

        case EVENT_UNSPECIFIED_ERROR:   // This should never be generated.
            log_info( "\r\n***** USB Error - unspecified *****\r\n" );
            return TRUE;
            break;

        case EVENT_SUSPEND:
        case EVENT_DETACH:
        case EVENT_RESUME:
        case EVENT_BUS_ERROR:
            return TRUE;
            break;

        default:
            break;
    }

    return FALSE;

} // USB_ApplicationEventHandler


void out_button_state(void)
{
	if(sense_ly>0){
		motor_a1_l();
		motor_a2_h();
		motor_pwma_write((PWM_DIGITAL_RUN_DUTY*(+sense_ly))/100);
	}else
	if(sense_ly<0){
		motor_a1_h();
		motor_a2_l();
		motor_pwma_write((PWM_DIGITAL_RUN_DUTY*(-sense_ly))/100);
	}else{
		motor_a1_h();
		motor_a2_h();
		motor_pwma_write(0);
	}

	if(sense_ry>0){
		motor_b1_l();
		motor_b2_h();
		motor_pwmb_write((PWM_DIGITAL_RUN_DUTY*(+sense_ry))/100);
	}else
	if(sense_ry<0){
		motor_b1_h();
		motor_b2_l();
		motor_pwmb_write((PWM_DIGITAL_RUN_DUTY*(-sense_ry))/100);
	}else{
		motor_b1_h();
		motor_b2_h();
		motor_pwmb_write(0);
	}
}

int main ( void )
{
	RestartWatchdog();

    // Initialize the processor and peripherals.
    if ( InitializeSystem() != TRUE )
    {
        log_info( "\r\n\r\nCould not initialize - system.  Halting.\r\n\r\n" );
        while (1);
    }
	xdev_out(UART1PutChar);

    if ( USBHostInit(0) == TRUE )
    {
        log_info( "\r\n\r\n***** Initialized *****\r\n\r\n" );
    }
    else
    {
        log_info( "\r\n\r\nCould not initialize - USB.  Halting.\r\n\r\n" );
        while (1);
    }

    // Main Processing Loop
    while(!deviceAddress)
    {
        // This demo does not check for overcurrent conditions.  See the
        // USB Host - Data Logger for an example of overcurrent detection
        // with the PIC24F and the USB PICtail Plus.

        // Maintain USB Host State
        USBHostTasks();

        //if (CheckForNewAttach()){
		//	break;
        //}
    }

	DelayMs(1000);

	blemain();

    return 0;

} // main


void hal_tick_init(void)
{
	usb_tick_handler=NULL;
}

void hal_tick_set_handler(void (*tick_handler)(void))
{
	usb_tick_handler=tick_handler;
}

#if	ENABLE_KNIGHTRIDER
#define	KR_LEDS			  8
#define	KR_SPWM_WIDTH	 16
#define	KR_CYCLE		128
#define	kr_led_write(x,y)	{if(y){kr_led ## x ## _on();}else{kr_led ## x ## _off();}}
#define	KR_LUM_STEP		  4
#define	KR_LED_PATTERNS	(KR_LEDS*2)
void	knightrider(void)
{
	static uint8_t	led_lum[KR_LEDS];
	static uint8_t	spwm_progress;
	static uint8_t	kr_progress,kr_pat_progress;
	uint8_t			i;

	kr_led_write(1,led_lum[0]>spwm_progress);
	kr_led_write(2,led_lum[1]>spwm_progress);
	kr_led_write(3,led_lum[2]>spwm_progress);
	kr_led_write(4,led_lum[3]>spwm_progress);
	kr_led_write(5,led_lum[4]>spwm_progress);
	kr_led_write(6,led_lum[5]>spwm_progress);
	kr_led_write(7,led_lum[6]>spwm_progress);
	kr_led_write(8,led_lum[7]>spwm_progress);
	spwm_progress=(spwm_progress+1)&(KR_SPWM_WIDTH-1);
	kr_progress=(kr_progress+1)&(KR_CYCLE-1);

	if(!kr_progress){
		for(i=0;i<KR_LEDS;i++){
			led_lum[i]>>=1;
		}
		if(kr_pat_progress<KR_LEDS){
			led_lum[kr_pat_progress]=KR_SPWM_WIDTH;
		}else{
			led_lum[(KR_LEDS-1)-(kr_pat_progress-KR_LEDS)]=KR_SPWM_WIDTH;
		}
		kr_pat_progress=(kr_pat_progress+1)&(KR_LED_PATTERNS-1);
	}
	return;
}
#endif

void hal_tick_event(void)
{
	timer_counter++;

	RestartWatchdog();

	if(!startup_state && timer_counter>5000){
		Reset();
	}

	if(connection_status){
        if(timer_counter&0x100){
            led2_off();
        }else{
            led2_on();
        }
	}else{
		led2_on();
	}

#if	0
	if(led1_on_state && (timer_counter-led1_on_count)>LED1_ON_COUNT){
		led1_off();
		led1_on_state=0;
	}
#endif

	// call tick handler
	if(usb_tick_handler){
		usb_tick_handler();
	}
#if	ENABLE_KNIGHTRIDER
	knightrider();
#endif

}

/*************************************************************************
 * EOF main.c
 */

